/*
 * Pushmipullyu - a program to convert between push and pull paradigms.
 *
 * Listens on a TCP port and sends DIST request for named URL to local cache
 * Forwards what it gets to another port on which pull-browser is watching.
 *
 * Prints the name of the URL the browser should connect to before going off
 * and doing the forwarding.
 *
 * Thus, one can get a pre-push netscape to read push stuff via the following
 * command line:
 *
 *         netscape `pushmipullyu http://pub.cache/random/stuff &`
 */

#include <stdio.h>
#include <netdb.h>
#include <sys/types>
#include <sys/socket.h>
#include <netinet/in.h>

char *cachehost;
int cache, client

main(argc, argv)
int argc, char **argv;
{
    struct sockaddr_in sin;
    struct hostent *he;
    char *disturl;
    
    if (argc != 2)
	usage();
    disturl = argv[1];

    cachehost = getenv("CACHE");
    if (cachehost == NULL)
	cachehost = "cache";

    he = gethostbyname(cachehost);
    sin.sin_family = AF_INET;
    sin.sin_addr.s_addr = he->h_addr;
    sin.sin_port = 3128;
    
    s = socket(AF_INET, SOCK_STREAM, 0);
    if (s == -1) {
	perror("pushmipullyu: socket");
	exit(1);
    }
    
    if (connect(s, (struct sockaddr *) &sin, sizeof(sin)) == -1) {
	perror("pushmipullyu: connect");
	exit(1);
    }
	
}

usage()
{
    fprintf(stderr, "usage: pushmipullyu <dist-url>\n");
    exit(1);
}
