/*
 *------------------------------------------------------------------
 *
 * LESS Group 
 * Computer Sciences Department 
 * University of Texas at Austin
 *
 * HCHintCache.h ---
 *          High-level interface to hint cache.
 *
 * $Date: 1998/04/02 20:57:54 $ $Id: HCHintCache.h,v 1.6 1998/04/02 20:57:54 dahlin Exp $
 *
 * Copyright (c) 1997 by Mike Dahlin.
 * 
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for noncommercial use without fee and
 * without written agreement is hereby granted, provided that 
 * the above copyright notice appear in all copies of this software.
 * 
 *------------------------------------------------------------------
 */
#ifndef _HCHintCache_h_
#define _HCHintCache_h_
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

/*
 * Interface to squid
 */


/* 
 *XXX I assume that the struct sockaddr * is a pointer to a thing
 *XXX that will never go away
 */
/* open existing cache; return nonzero on error */
int HCInit _PARAMS((void));
void HCCreate _PARAMS((void));              /* create new cache */
void HCDestroy _PARAMS((void));
void HCinformLocalCopy _PARAMS((char *url)); /* tell hierarchy I have a copy */
void HCinvalLocalCopy _PARAMS((char *url)); /* tell hierarchy I don't have a copy */
int HCActive _PARAMS((void));  /* Ask hint cache if it is operational. */
struct sockaddr_in *HCfindNearest _PARAMS((char *url, struct sockaddr_in *));

/*
 * Callbacks from squid network
 */
/* gets called every so often to flush StoreEntrys */
void HCTimer _PARAMS((void)); 

void HCHintCache_selfTest _PARAMS((void));

#define HC_ACTIVE()  (hcDisk != NULL)

#endif _HCHintCache_h_
