/*
 *------------------------------------------------------------------
 *
 * LESS Group 
 * Computer Sciences Department 
 * University of Texas at Austin
 *
 * HCNet ---
 *          Simple send interface built on squid async send stuff.
 *
 * $Date: 1998/05/04 18:42:40 $ $Id: HCNet.h,v 1.8 1998/05/04 18:42:40 dahlin Exp $
 *
 * Copyright (c) 1997 by Mike Dahlin.
 * 
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for noncommercial use without fee and
 * without written agreement is hereby granted, provided that 
 * the above copyright notice appear in all copies of this software.
 * 
 *------------------------------------------------------------------
 */

#ifndef _HCNet_h_
#define _HCNet_h_


#define HCVERSION "0.1devel"   /* Protocol version */

enum HCNet_State {HC_uninitialized, HC_filling, HC_full, HC_destroyed};

typedef struct HCNetS{
  StoreEntry *sendBuffer;
  int         sendLength;
  enum HCNet_State state;
  int         testMode;
  int         testCount;
} HCNet;

extern HCNet *parentOutgoingA;
extern HCNet *childrenOutgoingA;
extern HCNet *neighborsOutgoing;



void HCNet_Init _PARAMS((HCNet *n));
int HCNet_IsInitialized _PARAMS((void));
void HCNet_Destroy _PARAMS((HCNet *n));
void HCNet_Enqueue _PARAMS((HCNet *n, int action, HCEntry *, int hopcount));
int HCNet_bytesReady _PARAMS((HCNet *n));
void HCNet_Complete _PARAMS((HCNet *n));
void HCNet_Done _PARAMS((HCNet *n));
void HCNet_SendTo _PARAMS((HCNet *, struct sockaddr_in *));
void HCNet_SendJoin _PARAMS((void));
void HCNet_DataArrives _PARAMS((char *data, int len, int oneUpdateSize,
				struct sockaddr *source));
void HCNet_SetTestMode(HCNet *n);
int HCNet_GetTestCount(HCNet *n);

#endif _HCNet_h_
