
/*
 * Directory format
 * A list of files in the directory, each occupying one line:
 *
 *   <name> <optional-misc-info>
 *
 * e.g., for http://fooble.net/users, you might see
 *
 *   al
 *   bob
 *
 * Initial format contains no <optional-misc-info>, but parsers must
 * be prepared for it.
 * Directory format will always be in text/ascii.
 */ 

void dirSend(fd, StoreEntry *entry)
{
}

void dirRecv(fd, StoreEntry *entry)
{
}

void dirAddName(StoreEntry *child)
{
    char *dirname = xstrdup(child->url);
    StoreEntry *dire;
    char *slash;
    char *key;
    

    /* Chop off last slash */
    slash = strrchr(dirname, '/');
    *slash = '\0';

    key = storeGeneratePublicKey(key, METHOD_GET);
    dire = storeGet(key);
    if (dire == NULL) {
	/* No such directory yet.  Create one */
	dire = dirNew(dirname, key);
    }

    dirDist(dire);
}

static StoreEntry *
dirNew(char *name, char *key)
{
    StoreEntry *entry;
    int flags;
    
    BIT_SET(flags, REQ_CACHABLE);
    BIT_SET(flags, KEEP_INMEM);
    entry = storeCreateEntry(name, name, NULL, 0, flags, METHOD_GET);
    entry->mem_obj->request = urlParse(METHOD_GET, (char *) url);
    return(entry);
}

void dirDelName(char *dirname, *fname)
{
    
}

static void dirDist(CacheDir *cdir)
{
}
